/* Problem URL: https://codeforces.com/edu/course/2/lesson/9/3/practice/contest/307094/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vi a1(n);
    cin >> a1;

    cin >> n;
    vi a2(n);
    cin >> a2;

    cin >> n;
    vi a3(n);
    cin >> a3;

    cin >> n;
    vi a4(n);
    cin >> a4;

    sortv(a1);
    sortv(a2);
    sortv(a3);
    sortv(a4);

    int i = 0;
    int j = 0;
    int k = 0;
    int l = 0;

    int ans = INT32_MAX >> 1;
    int ans1;
    int ans2;
    int ans3;
    int ans4;

    while (i < a1.size() && j < a2.size() && k < a3.size() && l < a4.size()) {
        int tmp = max({a1[i], a2[j], a3[k], a4[l]}) - min({a1[i], a2[j], a3[k], a4[l]});

        if (tmp <= ans) {
            ans = tmp;
            ans1 = a1[i];
            ans2 = a2[j];
            ans3 = a3[k];
            ans4 = a4[l];
        }

        int act = min({a1[i], a2[j], a3[k], a4[l]});

        if (a1[i] == act) {
            i++;
            continue;
        }

        if (a2[j] == act) {
            j++;
            continue;
        }

        if (a3[k] == act) {
            k++;
            continue;
        }

        l++;
    }

    cout << ans1 << ' ' << ans2 << ' ' << ans3 << ' ' << ans4 << '\n';
}
